﻿package com.minnsLangton.view 
{
	import com.minnsLangton.view.components.*;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.mediator.Mediator;
	import com.minnsLangton.model.SiteEvents;
	/**
	* ...
	* @author Tim Ashworth
	*/
	public class MainViewMediator extends Mediator
	{
		public static const NAME:String = "mainViewMediator";
		
		private var aboutUs:AboutUs;
		private var where:Where;
		private var whatWeDo:WhatWeDo;
		private var contactUs:ContactUs;
		private var references:References
		
		private var siteHolder:SiteHolder;
		
		private var state:String = SiteEvents.ABOUT_PAGE;
		
		public function MainViewMediator(viewComponent:Object) 
		{
			super(NAME, viewComponent);
			createSite();
			siteHolder.fadeIn();
		}
		
		public function createSite():void
		{
			siteHolder = new SiteHolder();
			siteHolder.y = 48;
			main.addChild(siteHolder);
			
			aboutUs = new AboutUs();
			siteHolder.addPage(aboutUs,SiteEvents.ABOUT_PAGE);
			
			whatWeDo = new WhatWeDo();
			siteHolder.addPage(whatWeDo,SiteEvents.WHAT_PAGE);
			
			where = new Where();
			siteHolder.addPage(where,SiteEvents.WHERE_PAGE);
			
			references = new References();
			siteHolder.addPage(references,SiteEvents.REF_PAGE);
			
			contactUs = new ContactUs();
			siteHolder.addPage(contactUs,SiteEvents.CONTACT_PAGE);
		}
		
		override public function listNotificationInterests():Array
		{
			return [
					SiteEvents.ABOUT_PAGE,
					SiteEvents.CONTACT_PAGE,
					SiteEvents.REF_PAGE,
					SiteEvents.WHAT_PAGE,
					SiteEvents.WHERE_PAGE,
					SiteEvents.TRIGGER_START
					];
		}
		
		override public function handleNotification(note:INotification):void
		{
			switch(note.getName())
			{
				case SiteEvents.ABOUT_PAGE:
				navigateToPage(note.getName(), 0);
				break;
				case SiteEvents.CONTACT_PAGE:
				navigateToPage(note.getName(), -4000);
				break;
				case SiteEvents.REF_PAGE:
				navigateToPage(note.getName(), -3000);
				break;
				case SiteEvents.WHAT_PAGE:
				navigateToPage(note.getName(), -1000);
				break;
				case SiteEvents.WHERE_PAGE:
				navigateToPage(note.getName(), -2000);
				break;
				case SiteEvents.TRIGGER_START:
				siteHolder.showContent();
				break;
			}
		}
		
		private function navigateToPage(page:String,pos:Number):void
		{
			if (page != state)
			{
				state = page;
				siteHolder.navigateToPage(page, pos);
			}
		}
		
		public function get main():Main
		{
			return Main(viewComponent);
		}
		
	}
	
}