﻿package com.minnsLangton.view 
{
	import com.minnsLangton.view.components.Nav;
	import flash.events.Event;
	import org.puremvc.as3.patterns.mediator.Mediator;
	import com.minnsLangton.model.SiteEvents;
	/**
	* ...
	* @author Tim Ashworth
	*/
	public class NavMediator extends Mediator
	{
		public static const NAME:String = "navMediator";
		
		private var nav:Nav;
		
		public function NavMediator(viewComponent:Object = null) 
		{
			super(NAME, viewComponent);
			createNav();
		}
		
		public function createNav():void
		{
			nav = new Nav();
			main.addChild(nav);
			nav.addEventListener("about", gotoAbout);
			nav.addEventListener("what", gotoWhat);
			nav.addEventListener("where", gotoWhere);
			nav.addEventListener("ref", gotoRef);
			nav.addEventListener("contact", gotoContact);
			nav.addEventListener("navLoaded",triggerStart);
			nav.fadeIn();
		}
		
		private function gotoAbout(e:Event):void
		{
			sendNotification(SiteEvents.ABOUT_PAGE);
			nav.setSelected("about");
		}
		
		private function gotoWhat(e:Event):void
		{
			sendNotification(SiteEvents.WHAT_PAGE);
			nav.setSelected("what");
		}
		
		private function gotoWhere(e:Event):void
		{
			sendNotification(SiteEvents.WHERE_PAGE);
			nav.setSelected("where");
		}
		
		private function gotoRef(e:Event):void
		{
			sendNotification(SiteEvents.REF_PAGE);
			nav.setSelected("ref");
		}
		
		private function gotoContact(e:Event):void
		{
			sendNotification(SiteEvents.CONTACT_PAGE);
			nav.setSelected("contact");
		}
		
		private function triggerStart(e:Event):void
		{
			sendNotification(SiteEvents.TRIGGER_START);
		}
		
		public function get main():Main
		{
			return Main(viewComponent);
		}
		
	}
	
}