﻿package com.minnsLangton.view.components 
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import gs.TweenLite;
	/**
	* ...
	* @author Tim Ashworth
	*/
	public class Nav extends MovieClip
	{
		private var aboutBtn:AboutBtn;
		private var whatBtn:WhatBtn;
		private var whereBtn:WhereButton;
		private var refBtn:RefBtn;
		private var contactUsBtn:ContactBtn;
		
		private var btnArr:Array;
		
		private var selectedBtn:MinnsButton;
		
		private var targetY:Number = 42;
		
		public function Nav() 
		{
			this.alpha = 0;
			btnArr = new Array();
			
			aboutBtn = this.about_btn;
			aboutBtn.eventType = "about";
			
			btnArr.push(aboutBtn);
			
			whatBtn = this.what_btn;
			whatBtn.eventType = "what";
			
			btnArr.push(whatBtn);
			
			whereBtn = this.where_btn;
			whereBtn.eventType = "where";
			
			btnArr.push(whereBtn);
			
			refBtn = this.references_btn;
			refBtn.eventType = "ref";
			
			btnArr.push(refBtn);
			
			contactUsBtn = this.contact_btn;
			contactUsBtn.eventType = "contact";
			
			btnArr.push(contactUsBtn);
			
			applyListeners();
			
			aboutBtn.gotoAndStop(2);
			aboutBtn.selected = true;
			selectedBtn = aboutBtn;
			
			for (var i:int = 0; i < btnArr.length; i++)
			{
				btnArr[i].y = 0;
				btnArr[i].visible = false;
			}
			
		}
		
		private function applyListeners():void
		{
			aboutBtn.addEventListener("about", navToPage);
			whatBtn.addEventListener("what",navToPage);
			whereBtn.addEventListener("where",navToPage);
			refBtn.addEventListener("ref",navToPage);
			contactUsBtn.addEventListener("contact",navToPage);
		}
		
		private function navToPage(e:Event):void
		{
			this.dispatchEvent(e);
		}
		
		public function setSelected(eventName:String):void
		{
			if (selectedBtn != null)
			{
				selectedBtn.gotoAndStop(1);
				selectedBtn.selected = false;
			}
			
			for (var i:int = 0; i < btnArr.length; i++)
			{
				if (btnArr[i].eventType == eventName)
				{
					btnArr[i].gotoAndStop(2);
					selectedBtn = btnArr[i];
					selectedBtn.selected = true;
					return;
				}
			}
		}
		
		public function fadeIn():void
		{
			TweenLite.to(this, 1, { alpha:1,delay:1,onComplete:displayNav } );
		}
		
		private function displayNav():void
		{
			for (var i:int = 0; i < btnArr.length; i++)
			{
				btnArr[i].visible = true;
				TweenLite.to(btnArr[i], 1, { y:targetY, delay:0.2 * i } );
			}
			var evntObj:Event = new Event("navLoaded");
			this.dispatchEvent(evntObj);
		}
	}
	
}