﻿package com.minnsLangton.view.components 
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import fl.transitions.easing.*;
	import gs.TweenLite;
	import com.minnsLangton.model.SiteEvents;
	/**
	* ...
	* @author Tim Ashworth
	*/
	public class SiteHolder extends MovieClip
	{	
		private var spacing:Number = 1000;
		private var xPos:Number = 0;
		
		private var currentPage:String;
		
		private var pageArray:Array;
		
		public function SiteHolder() 
		{
			pageArray = new Array();
			this.alpha = 0;
			currentPage = SiteEvents.ABOUT_PAGE;
		}
		
		public function addPage(clip:MinnsPage,name:String):void
		{
			clip.x = xPos;
			
			this.addChild(clip);
			pageArray.push( { name:name, clip:clip } );
			xPos += spacing;
		}
		
		public function navigateToPage(page:String, pos:Number):void
		{
			hideContent();
			TweenLite.to(this, 2, { x:pos, ease:Regular.easeOut,onComplete:showContent } );
			currentPage = page;
		}
		
		public function fadeIn():void
		{
			TweenLite.to(this, 1, { alpha:1 } );
		}
		
		public function showContent():void
		{
			var page:MinnsPage = getPage(currentPage);
			page.displayContent();
		}
		
		public function hideContent():void
		{
			var page:MinnsPage = getPage(currentPage);
			page.hideContent();
		}
		
		public function getPage(name:String):MinnsPage
		{
			var page:MinnsPage;
			for (var i:int = 0; i < pageArray.length; i++)
			{
				if (pageArray[i].name == currentPage)
				{
					page = pageArray[i].clip;
					break;
				}
			}
			return page;
		}
	}
}